-- $Id$
-- ToME - Tales of Middle-Earth
-- Copyright © 2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

local Quest = require 'engine.Quest'

store_util.set_prices(npc.store.owner, player, {
  id = {1400, 1300, 1200},
})

newChat {
  id = 'welcome',
  text = [[#LIGHT_GREEN#*A rather ostentatiously-dressed High-Elf librarian dusts off his jacket and straightens his spectacles as you enter.*#LAST#
Ah, welcome, noble adventurer, to Gondolin's renowned library.  Our stores of knowledge are vast, and our skilled staff can surely find detailed information about whatever magical items you may have found in your travels.  Or for your more plebeian identification needs, our gift shop sells Staffs of Identify.]],
  answers = {
    {
      'Can you research this item for me?' .. store_util.cost_sfx('id'),
      cond = store_util.ok_full_id_item,
      action = store_util.full_id_item,
    },
    {
      "Ooh, Staffs of Identify, I'm fresh out of those.",
      action = function(npc, player)
	npc.store:loadup(game.level, game.zone)
	npc.store:interact(player)
      end,
    },
    { 'Oh, sorry, I was looking for the weapon store. [leave]' },
  },
}

return 'welcome'
