-- $Id: thunderlords-nest.lua 3073 2017-09-17 00:49:21Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

store_util.set_prices(npc.owner, player, {
  recall = {300, 200, 100},
  tport = {15000, 10000, 1000},
})

local function do_recall(npc, player)
  player:adjGold(-cost_recall)
  spell.set_recall(player, 0, 1)
end

local function go_to_dungeon(npc, player)
  local ResetRecall = require 'mod.dialogs.ResetRecall'
  local function cb()
    player:adjGold(-cost_tport)
    spell.set_recall(player, 0, 1)
  end
  game:registerDialog(ResetRecall.new(false, nil, cb))
end

newChat {
  id = 'welcome',
  text = [[#LIGHT_GREEN#*You climb a ladder to a large platform on the roof of the building, peppered with scaffolds that rememble large tree branches.  Perched on one of them is a giant eagle that towers over you, tended by a tall Thunderlord in dark green flying gear who turns to you as you clamber onto the platform.*#LAST#
@playerdescriptor.race@, you have entered the eyrie of the Thunderlords, riders of the wind and travelers of the Straight Road.  If you seek passage, we can ferry you to many places; but we guard our secrets, and our services do not come cheap.]],
  answers = {
    {
      'Can you recall me back into the dungeon? [#YELLOW#' .. game.state.recall_dungeon.name .. '#LAST#]' .. store_util.cost_sfx('recall'),
      cond = store_util.can_afford('recall'),
      action = do_recall,
    },
    {
      'Can you transport me to another dungeon?' .. store_util.cost_sfx('tport'),
      cond = store_util.can_afford('tport'),
      action = go_to_dungeon,
    },
    { "Sorry, didn't mean to disturb you.  Cute eagle, by the way. [leave]" },
  }
}

newChat {
  id = 'welcome-tlord',
  text = [[#LIGHT_GREEN#*You climb a ladder to a large eyrie platform on the roof of the building, peppered with eagle perches.  Perched on one of them is an eagle much like yours, tended by a tall Thunderlord in dark green flying gear who turns to you as you clamber onto the platform.*#LAST#
Welcome to our eyrie, fellow windrider.  Do you and your eagle seek passage?]],
  answers = {
    {
      'Can you recall me back into the dungeon? [#YELLOW#' .. game.state.recall_dungeon.name .. '#LAST#]' .. store_util.cost_sfx('recall'),
      cond = store_util.can_afford('recall'),
      action = do_recall,
    },
    {
      'Can you transport me to another dungeon?' .. store_util.cost_sfx('tport'),
      cond = store_util.can_afford('tport'),
      action = go_to_dungeon,
    },
    { "Sorry, didn't mean to disturb you. [leave]" },
  }
}

if player.descriptor.race == 'Thunderlord' then
  return 'welcome-tlord'
else
  return 'welcome'
end
