-- $Id: traps.lua 3333 2018-04-20 00:32:38Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_obj' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Object entities generated from T2's k_info.txt

newEntity {
  base = 'TRAP_BASE',
  define_as = 'TRAP_ARROW',
  name = 'TRAP_ARROW',
  display_name = 'Arrow',
  desc = 'It must be loaded with arrows, which will be fired at the monster who triggers the trap.',
  sval = 2,
  color = colors.C_r,
  image = 'object/trap_arrow.png',
  level = 10,
  weight = 6,
  encumber = 6,
  cost = 150,
  combat = { 1, 1 },
  flags = { SHOW_MODS=true },
  allocation = {
    { level=10, rarity=2 },
    { level=50, rarity=2 },
  },
  -- BEGIN VERBATIM
  payload_filter = function(o)
    return o.type == 'ammo' and o.subtype == 'arrows'
  end,
  triggered = trap_util.trigger_ammo_trap,
  ammo_mult = 3,	-- cf. Object:ammoMult()
  -- END VERBATIM
}

newEntity {
  base = 'TRAP_BASE',
  define_as = 'TRAP_BOLT',
  name = 'TRAP_BOLT',
  display_name = 'Bolt',
  desc = 'It must be loaded with crossbow bolts, which will be fired at the monster who triggers the trap.',
  sval = 3,
  color = colors.C_o,
  image = 'object/trap_bolt.png',
  level = 20,
  weight = 22,
  encumber = 22,
  cost = 300,
  combat = { 1, 1 },
  flags = { SHOW_MODS=true },
  allocation = {
    { level=20, rarity=2 },
    { level=50, rarity=2 },
  },
  -- BEGIN VERBATIM
  payload_filter = function(o)
    return o.type == 'ammo' and o.subtype == 'bolts'
  end,
  triggered = trap_util.trigger_ammo_trap,
  ammo_mult = 4,	-- cf. Object:ammoMult()
  -- END VERBATIM
}

newEntity {
  base = 'TRAP_BASE',
  define_as = 'TRAP_CATAPULT',
  name = 'TRAP_CATAPULT',
  display_name = 'Catapult',
  desc = 'It must be loaded with sling bullets, which will be fired at the monster who triggers the trap.',
  sval = 1,
  color = colors.C_R,
  image = 'object/trap_catapult.png',
  level = 1,
  weight = 5,
  encumber = 5,
  cost = 40,
  combat = { 1, 1 },
  flags = { SHOW_MODS=true },
  allocation = {
    { level=1, rarity=2 },
    { level=20, rarity=2 },
  },
  -- BEGIN VERBATIM
  payload_filter = function(o)
    return o.type == 'ammo' and o.subtype == 'shots'
  end,
  triggered = trap_util.trigger_ammo_trap,
  ammo_mult = 2,	-- cf. Object:ammoMult()
  -- END VERBATIM
}

newEntity {
  base = 'TRAP_BASE',
  define_as = 'TRAP_FUMES',
  name = 'TRAP_FUMES',
  display_name = 'Fumes',
  desc = 'It must be loaded with potions, which will splatter over the monster who triggers the trap.',
  sval = 4,
  color = colors.C_G,
  image = 'object/trap_fumes.png',
  level = 2,
  weight = 2,
  encumber = 2,
  cost = 50,
  combat = { 1, 1 },
  allocation = {
    { level=2, rarity=2 },
    { level=30, rarity=2 },
  },
  -- BEGIN VERBATIM
  payload_filter = function(o)
    return o.type == 'utility' and o.subtype == 'potion' and o.in_trap
  end,
  triggered = trap_util.trigger_consumables_trap,
  trigger_msg = '@Target@ is hit by fumes.',
  resolvers.generic_last(function(e)
    -- This kind of trap kit doesn't have to-hit/to-dam fields.
    -- [cf. trap_hack() in src/traps.c]
    e.to_h, e.to_d = nil, nil
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'TRAP_BASE',
  define_as = 'TRAP_MAGIC',
  name = 'TRAP_MAGIC',
  display_name = 'Magic',
  desc = 'It must be loaded with scrolls, which will release their spells at the monster who triggers the trap.',
  sval = 5,
  color = colors.C_g,
  image = 'object/trap_magic.png',
  level = 5,
  weight = 2,
  encumber = 2,
  cost = 50,
  combat = { 1, 1 },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true, [DamageType.ELEC]=true },
  allocation = {
    { level=5, rarity=2 },
    { level=40, rarity=2 },
  },
  -- BEGIN VERBATIM
  payload_filter = function(o)
    return o.type == 'utility' and o.subtype == 'scroll' and o.in_trap
  end,
  triggered = trap_util.trigger_consumables_trap,
  trigger_msg = '@Target@ activates a spell!',
  resolvers.generic_last(function(e)
    -- This kind of trap kit doesn't have to-hit/to-dam fields.
    -- [cf. trap_hack() in src/traps.c]
    e.to_h, e.to_d = nil, nil
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}

newEntity {
  base = 'TRAP_BASE',
  define_as = 'TRAP_DEVICE',
  name = 'TRAP_DEVICE',
  display_name = 'Device',
  desc = 'It must be loaded with a magic device (wand, staff, or rod), which will fire its spell at the monster who triggers the trap.',
  sval = 6,
  color = colors.C_v,
  image = 'object/trap_device.png',
  level = 20,
  weight = 2,
  encumber = 2,
  cost = 50,
  combat = { 1, 1 },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true, [DamageType.ELEC]=true },
  allocation = {
    { level=20, rarity=2 },
    { level=40, rarity=2 },
    { level=60, rarity=2 },
  },
  -- BEGIN VERBATIM
  payload_filter = function(o)
    -- Wands and staffs don't currently do anything in traps, so we filter
    -- them out.
    return o.type == 'utility' and o.subtype == 'rod' and o.rod_tip and o.rod_tip.in_trap
  end,
  no_multi_payload = true,
  triggered = trap_util.trigger_device_trap,
  resolvers.generic_last(function(e)
    -- This kind of trap kit doesn't have to-hit/to-dam fields.
    -- [cf. trap_hack() in src/traps.c]
    e.to_h, e.to_d = nil, nil
    return nil	-- Delete the origin field
  end),
  -- END VERBATIM
}
-- 6 total items
-- color:  colors.C_G=1; colors.C_R=1; colors.C_g=1; colors.C_o=1; colors.C_r=1; colors.C_v=1
-- level:  1=1; 10=1; 2=1; 20=2; 5=1
-- weight:  20=3; 220=1; 50=1; 60=1
-- cost:  150=1; 300=1; 40=1; 50=3
