-- $Id: generic_bolt.lua 4252 2021-07-31 23:22:57Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2021 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- A *very* simple particle representing a "bolt" of some manner of spell
-- energy traveling from the source coordinates to a specified destination.
-- Particle parameters:
--
--   - dx, dy:		x/y distance (in grid coordinates) from source
--   			location to target location.
--   - rr, gg, bb:	Red/green/blue levels (range 0-255) to use for the
--   			particle.

local first = true
local dx = dx * engine.Map.tile_w
local dy = dy * engine.Map.tile_h
local size = engine.Map.tile_w/2
local n_frames = 5

return {
  generator = function()
    return {
      trail = 1,

      life = n_frames,
      size = size, sizev = 0, sizea = 0,

      x = 0, xv = dx/n_frames, xa = 0,
      y = 0, yv = dy/n_frames, ya = 0,

      r = rr/255, rv = 0, ra = 0,
      g = gg/255, gv = 0, ga = 0,
      b = bb/255, bv = 0, ba = 0,
      a = 1, av = 0, aa = 0
    }
  end
},
function(self)
  if first then
    self.ps:emit(n_frames)
    first = false
  end
end,
n_frames
