-- $Id: lothlorien-house.lua 3151 2017-10-31 01:18:08Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

id = 'lothlorien-house'
name = 'Wolves!'
danger_level = 15	-- cf. src/tables.c line 4154
desc = function(self, who)
  if self:isEnded() then
    return [[You have slain the wolves harrassing Lothlórien, and as a reward Celeborn has given you their abandoned den to use as a house.]]
  elseif self:isCompleted() then
    return [[You have slain the wolves harrassing Lothlórien.  You should return to the Seat of Ruling and tell Celeborn.]]
  else
    return [[Wolves are pestering the Elves of Lothlórien.  You must enter their den and clear them out.]]
  end
end

-- cf. util.no_reenter_completed_quest()
no_reenter_msg = [[You have already cleared the wolves' den.  You should go tell Celeborn.]]

on_quest_mon_die = function(self, who, src)
  -- Only interested in kills in the quest zone.
  if game.zone.short_name ~= 'quest-lothlorien-wolves' then return end
  -- If any hostiles are still alive, we're not done.
  for _, e in pairs(game.level.entities) do
    if e.reactionToward and e:reactionToward(game.player) < 0 and not e.dead then
      return
    end
  end
  -- Our work here... is done.
  game.log('#YELLOW#Lothlórien is safer now.#LAST#')
  game.player:setQuestStatus(self.id, self.COMPLETED)
end
