-- $Id: minas-anor-library.lua 3333 2018-04-20 00:32:38Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2018 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

id = 'minas-anor-library'
name = 'Library quest'
danger_level = 35	-- cf. lib/scpt/library.lua line 331

desc = function(self, who)
  if self:isFailed() then
    return [[You tried to clear the undead out of the Minas Anor library's deep stacks, but failed.]]
  elseif self:isEnded() then
    return [[You cleared the undead out of the Minas Anor library's deep stacks.  In return, the library's scribes created a custom spellbook for you.]]
  elseif self:isCompleted() then
    return [[You cleared the undead out of the Minas Anor library's deep stacks.  You should return to the library and tell the librarian.]]
  else
    return [[The Minas Anor library's deep stacks have become infested with undead.  You must slay all of them.]]
  end
end

on_quest_mon_die = function(self, who, src)
  -- Only interested in kills in the quest zone.
  if game.zone.short_name ~= 'quest-minas-anor-library' then return end
  -- If any hostiles are still alive, we're not done.
  for _, e in pairs(game.level.entities) do
    if e.reactionToward and e:reactionToward(game.player) < 0 and not e.dead then
      return
    end
  end
  -- Our work here... is done.
  game.log('#YELLOW#The library is safe now.#LAST#')
  game.player:setQuestStatus('minas-anor-library', self.COMPLETED)
end
