-- $Id: fire.lua 4252 2021-07-31 23:22:57Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2021 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_fire.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Fire spells',
  type = 'spell/fire',
  description = 'Spells from the Fire school',
}

newTalent {
  name = [[Globe of Light]],
  short_name = 'GLOBE_LIGHT',
  display_entity = Entity.new { image='talents/globe_of_light.png' },
  type = 'spell/fire',
  mode = 'activated',
  is_spell = true,
  skill = 'FIRE',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 2,
  max_mana = 15,
  base_fail = 10,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 40 },
  stick = {
    type = 'utility/staff',
    charge = { 10, 5 },
    rarity = 7,
    base_level = { 1, 15 },
    max_level = { 10, 45 },
  },
  points = 0,
  range = 18,
  particle = spell.simple_bolt_particle,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    spell.lite_room(self.x, self.y)
    if lev >= 3 then
      if not self:has('BLIND') then
	game.logPlayer(self, 'You are surrounded by a white light.')
      end
      spell.ball_spell(self, t, DamageType.LITE_WEAK, 10, 4, self.x, self.y)
    end
    if lev >= 15 then
      local dam = 10 + spell.get_spell_level(self, t, 100)
      local r = 5 + spell.get_spell_level(self, t, 6)
      spell.ball_spell(self, t, DamageType.LITE, dam, r, self.x, self.y)
    end
    spell.stick.id = true
    return true
  end,
  info = function(self, t)
    local dam = 10 + spell.get_spell_level(self, t, 100)
    local r = 5 + spell.get_spell_level(self, t, 6)
    local wlf = util.colorize_damtype(DamageType.LITE_WEAK)
    local lf = util.colorize_damtype(DamageType.LITE)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Lights the room around the caster.  Starting at level 3, also projects a globe of light, doing 10 %s damage to light-sensitive monsters in a radius of 4 around the caster.  Starting at level 15, projects a second, stronger globe of light, doing %d %s damage to all monsters in a radius of %d around the caster; damage and radius of this second globe will increase%s]]
    return ret:format(wlf, dam, lf, r, sfx)
  end,
}

newTalent {
  name = [[Fire Golem]],
  short_name = 'FIRE_GOLEM',
  display_entity = Entity.new { image='talents/fire_golem.png' },
  type = 'spell/fire',
  mode = 'activated',
  is_spell = true,
  skill = { 'FIRE', 'MIND' },
  skill_level = 7,
  mana = spell.mana_cost,
  min_mana = 16,
  max_mana = 70,
  base_fail = 40,
  stat = 'INT',
  random_book = 'MAGIC',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
			local m_idx, y, x, ret, item

			-- Can we reconnect ?
			if do_control_reconnect() == TRUE then
				msg_print("Control re-established.")
				return
			end

			ret, item = get_item("Which light source do you want to use to create the golem?",
					     "You have no light source for the golem",
					     bor(USE_INVEN, USE_EQUIP),
					     function (obj)
						if (obj.tval == TV_LITE) and ((obj.sval == SV_LITE_TORCH) or (obj.sval == SV_LITE_LANTERN)) then
							return TRUE
							end
							return FALSE
					     end
			)
			if ret == FALSE then return TRUE end
			inven_item_increase(item, -1)
			inven_item_describe(item)
			inven_item_optimize(item)

			-- Summon it
			m_allow_special[1043 + 1] = TRUE
			y, x = find_position(player.py, player.px)
			m_idx = place_monster_one(y, x, 1043, 0, FALSE, MSTATUS_FRIEND)
			m_allow_special[1043 + 1] = FALSE

			-- level it
			if m_idx ~= 0 then
				monster_set_level(m_idx, 7 + get_level(FIREGOLEM, 70))
				player.control = m_idx
				monster(m_idx).mflag = bor(monster(m_idx).mflag, MFLAG_CONTROL)
			end
			return TRUE
	end,
  info = [[Creates a fiery golem and controls it During the control the available keylist is: Movement keys: movement of the golem(depending on its speed                it can move more than one square) , : pickup all items on the floor d : drop all carried items i : list all carried items m : end the possession/use golem powers Most of the other keys are disabled, you cannot interact with your real body while controlling the golem But to cast the spell you will need a lantern or a wooden torch to Create the golem from]],
  info_aux = function(self, t)
			return "golem level "..(7 + get_level(FIREGOLEM, 70))
	end,
}

newTalent {
  name = [[Fireflash]],
  short_name = 'FIREFLASH',
  display_entity = Entity.new { image='talents/fireflash.png' },
  type = 'spell/fire',
  mode = 'activated',
  is_spell = true,
  skill = 'FIRE',
  skill_level = 10,
  mana = spell.mana_cost,
  min_mana = 5,
  max_mana = 70,
  base_fail = 35,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 5, 5 },
    rarity = 35,
    base_level = { 1, 15 },
    max_level = { 15, 35 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  particle = spell.simple_ball_particle,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local dt = lev >= 20 and DamageType.HOLY_FIRE or DamageType.FIRE
    local dam = 20 + spell.get_spell_level(self, t, 200)
    local r = 2 + spell.get_spell_level(self, t, 5)
    local ret = spell.ball_spell(self, t, dt, dam, r)
    if ret then spell.stick.id = true end
    return ret
  end,
  info = function(self, t)
    local dam = 20 + spell.get_spell_level(self, t, 200)
    local r = 2 + spell.get_spell_level(self, t, 5)
    local ff = util.colorize_damtype(DamageType.FIRE)
    local hff = util.colorize_damtype(DamageType.HOLY_FIRE)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Conjures a ball of fire, doing %d %s damage in a radius of %d around the target.  At level 20 it turns into a ball of %s.  Damage and radius will increase%s]]
    return ret:format(dam, ff, r, hff, sfx)
  end,
}

newTalent {
  name = [[Firewall]],
  short_name = 'FIREWALL',
  display_entity = Entity.new { image='talents/firewall.png' },
  type = 'spell/fire',
  mode = 'activated',
  is_spell = true,
  skill = 'FIRE',
  skill_level = 15,
  mana = spell.mana_cost,
  min_mana = 25,
  max_mana = 100,
  base_fail = 40,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 4, 5 },
    rarity = 55,
    base_level = { 1, 10 },
    max_level = { 5, 40 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  particle = spell.simple_beam_particle,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local dt = lev >= 6 and DamageType.HELL_FIRE or DamageType.FIRE
    local dam = 40 + spell.get_spell_level(self, t, 150)
    local dur = 10 + spell.get_spell_level(self, t, 14)
    local ret = spell.wall_spell(self, t, dt, dam, dur)
    if ret then spell.stick.id = true end
    return ret
  end,
  info = function(self, t)
    local dam = 40 + spell.get_spell_level(self, t, 150)
    local dur = 10 + spell.get_spell_level(self, t, 14)
    local ff = util.colorize_damtype(DamageType.FIRE)
    local hff = util.colorize_damtype(DamageType.HELL_FIRE)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Creates a fiery wall to incinerate monsters stupid enough to attack you, doing %d %s damage per turn for %d turns.  At level 6 it turns into a wall of %s.  Damage and duration will increase%s]]
    return ret:format(dam, ff, dur, hff, sfx)
  end,
}

newTalent {
  name = [[Fiery Shield]],
  short_name = 'FIRE_SHIELD',
  display_entity = Entity.new { image='talents/fiery_shield.png' },
  type = 'spell/fire',
  mode = 'activated',
  is_spell = true,
  skill = 'FIRE',
  skill_level = 20,
  mana = spell.mana_cost,
  min_mana = 20,
  max_mana = 60,
  base_fail = 50,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 2, 15 },
  stick = {
    type = 'utility/staff',
    charge = { 3, 5 },
    rarity = 50,
    base_level = { 1, 10 },
    max_level = { 5, 40 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local dt = lev >= 8 and DamageType.SHIELDFIRE or DamageType.FIRE
    local base_dur = 10 + spell.get_spell_level(self, t, 70)
    local dd, ds = t.dmg_dice(self, t)
    local p = {
      power = 10,
      on_melee_hit = { type=dt, dice={dd,ds} },
      shield_name = 'Fiery Shield',
    }
    if not self:hasEffect(self.EFF_SHIELD) then spell.stick.id = true end
    self:setEffect(self.EFF_SHIELD, base_dur+rng.range(1,20), p)
    return true
  end,
  info = function(self, t)
    local base_dur = 10 + spell.get_spell_level(self, t, 70)
    local dd, ds = t.dmg_dice(self, t)
    local ff = util.colorize_damtype(DamageType.FIRE)
    local gff = util.colorize_damtype(DamageType.SHIELDFIRE)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Creates a shield of fierce fire around you, increasing your AC by 10 and dealing %dd%d %s damage to attackers for %d+1d20 turns.  At level 8, the damage becomes unresistable %s damage.  Damage and duration will increase%s]]
    return ret:format(ds, dd, ff, base_dur, gff, sfx)
  end,
  -- BEGIN VERBATIM
  dmg_dice = function(self, t)
    local dd = 5 + spell.get_spell_level(self, t, 10)
    local ds = 5 + spell.get_spell_level(self, t, 7)
    return dd, ds
  end,
  -- END VERBATIM
}
