-- $Id: tulkas.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_tulkas.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Tulkas prayers',
  type = 'spell/tulkas',
  description = 'Prayers to Tulkas',
}

newTalent {
  name = [[Divine Aim]],
  short_name = 'TULKAS_DIVINE_AIM',
  display_entity = Entity.new { image='talents/divine_aim.png' },
  type = 'spell/tulkas',
  mode = 'activated',
  is_spell = true,
  skill = 'PRAYER',
  skill_level = 1,
  piety = spell.mana_cost,
  min_piety = 30,
  max_piety = 500,
  god = 'Tulkas',
  base_fail = 20,
  stat = 'WIS',
  random_book = 'SPIRITUALITY',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local dur = spell.get_spell_level(self, t, 50) + rng.range(1, 10)
    self:setEffect(self.EFF_DIVINE_AIM, dur, {})
    if lev >= 20 then
      self:setEffect(self.EFF_DEADLY_AIM, dur, {})
    end
    return true
  end,
  info = function(self, t)
    local base_dur = spell.get_spell_level(self, t, 50)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[You call upon Tulkas to guide your hand in combat, increasing to-hit and to-dam by +15 for %d+1d10.  At level 20 your next %d+1d10 blows will be critical hits.  Duration and number of criticals will increase%s]]
    return ret:format(base_dur, base_dur, sfx)
  end,
}

newTalent {
  name = [[Whirlwind]],
  short_name = 'TULKAS_WHIRLWIND',
  display_entity = Entity.new { image='talents/whirlwind.png' },
  type = 'spell/tulkas',
  mode = 'activated',
  is_spell = true,
  skill = 'PRAYER',
  skill_level = 10,
  piety = spell.mana_cost,
  min_piety = 100,
  max_piety = 100,
  god = 'Tulkas',
  base_fail = 45,
  stat = 'WIS',
  random_book = 'SPIRITUALITY',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    return spell.ball_spell(self, t, DamageType.ATTACK, 1, 1, self.x, self.y)
  end,
  info = function(self, t)
    return [[You spin around, striking all adjacent monsters with a single melee blow.]]
  end,
}

newTalent {
  name = [[Wave of Power]],
  short_name = 'TULKAS_WAVE_POWER',
  display_entity = Entity.new { image='talents/wave_of_power.png' },
  type = 'spell/tulkas',
  mode = 'activated',
  is_spell = true,
  skill = 'PRAYER',
  skill_level = 20,
  piety = spell.mana_cost,
  min_piety = 200,
  max_piety = 200,
  god = 'Tulkas',
  base_fail = 75,
  stat = 'WIS',
  random_book = 'SPIRITUALITY',
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local blows, _ = t.num_project(self, t)
    return spell.bolt_spell(self, t, DamageType.ATTACK,
			    { blows, silent_0dam=true }, nil, nil, nil)
  end,
  info = function(self, t)
    local blows, all_blows = t.num_project(self, t)
    local s = blows == 1 and '' or 's'
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Strike at a distant foe with your weapon(s) or unarmed attacks as though you were attacking in melee.  You will project %d blow%s out of your usual %d; this will increase%s]]
    return ret:format(blows, s, all_blows, sfx)
  end,
  -- BEGIN VERBATIM
  num_project = function(self, t)
    local ms = self:getMeleeStyle()
    local wpns = ms.all_weapons(self)
    local all_blows = ms.num_blows(self, wpns[1])
    local blows = spell.get_spell_level(self, t, all_blows)
    return blows, all_blows
  end,
  -- END VERBATIM
}
