-- $Id: zone.lua 3850 2020-04-05 20:13:34Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2020 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- Zone file for Halls of Mandos.

return {
  name = 'Halls of Mandos',
  display_abbr = 'HMa',
  level_scheme = 'fixed',
  max_level = 98,
  level_range = { 1, 98 },
  width = 198,
  height = 66,

  generator = {
    map = {
      class = 'mod.class.generator.map.T2DungeonLevel',
      floor = { 'FLOOR' },
      fill = { 'WALL' },
      outer_wall = 'WALL',
      inner_wall = 'WALL',
      fill_step = 0,
      up = 'UP',
      down = 'DOWN',
      flags = {
	RANDOM_TOWNS = true,
	NO_RECALL = true,
	NO_SHAFT = true,
      },
    },
    actor = {
      class = 'mod.class.generator.actor.T2LevelFilteredActors',
      init_npc = 14,
      respawn_in = 160,
      filters = {
	{ prob=100, mode='nand', flags={ 'UNIQUE' } },
      },
    },
    object = {
      class = 'mod.class.generator.object.T2LevelFilteredObjects',
      weights = { treasure=20, combat=20, magic=20, tools=20, junk=20 },
    },
    trap = {
      class = 'mod.class.generator.trap.T2LevelFilteredTraps',
    },
  },
  alter_level_data = util.adjust_level,
  levels = {
    [1] = {
      generator = {
	map = {
	  up = 'UP_TO_WILDERNESS',
	  -- up_lev = 1
	},
      },
    },
  },
}
