-- $Id: init.lua 4264 2021-08-03 23:45:10Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2021 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

name = "T.o.M.E Classic"
long_name = "Tales of Middle Earth (T2) for T-Engine4"
short_name = "tome2"
author = { "Scott Bigham", "dsb-tome@killerbunnies.org" }
homepage = "http://www.killerbunnies.org/angband/"
version = { 0, 5, 3 }
engine = { 1,7,4,"te4" }
description = [[
The original Tales of Middle Earth v2.3.9 (or a reasonable approximation thereof) ported to the TE4 engine.

See the "#LIGHT_BLUE#Credits#LAST#" entry on the game menu for credits for the module.
]]
starter = "mod.load"

no_get_name = true	-- Handle name juggling ourself.
allow_userchat = true	-- Let's be social, why not? ;)

-- Honor the censor_boot setting.
background_name = config.settings.censor_boot and {"tome3"} or {"tome","tome2","tome3"}

-- [Note to self:  search log for "Wait finished, counted NNN, MMM ticks"
--  after a "done loading module" for our module; NNN is the number we want
--  here.]
loading_wait_ticks = 174

-- These appear to be called from engine.Module:instanciate().
font_package_id = function()
  local ui_font = config.settings.tome2 and config.settings.tome2.ui_font or 'fantasy/normal'
  return ui_font:split('/')[1]
end
font_package_size = function()
  local ui_font = config.settings.tome2 and config.settings.tome2.ui_font or 'fantasy/normal'
  return ui_font:split('/')[2]
end

load_tips = {
  { text = [[This is a test.  This is only a test.]] },
  { text = '[WATCH THIS SPACE]' },
  { text = '[Sorry, not implemented (random tip)]' },
  { text = 'Congratulations!  You found the secret easter egg!' },
  { text = 'Error:  Random tip not found, file RandomTips.lua line 4269' },
  { text = 'The quickest way to safely kill Great Wyrms of Power is to' },
  { text = 'Dungeon construction in progress.  Hard hats required beyond this point.' },
  { text = [[Accepted quest 'Beta tester'! (Press 'Ctrl-Q' to see the quest log)]] },
  { text = [[You identify:  the Long Sword 'Excalibur' (+15,+15) (+3) {yeah, no...}]] },
  { text = [[You can see exactly how close you are to starving by setting the "Food display" game option.]] },
  { text = [[You can deliberately walk onto and trigger a trap by typing Ctrl-Shift-D while standing next to it.]] },
  { text = [[The 'Show antimagic field' option will let you see how close you need to get to those filthy spellcasters to stop them casting their spells at you.]] },
  { text = [[There's no real difference between a Strength of 39.8 and 39.9, but it's nice to know it's there.]] },
  { text = [[Alchemists have the ability to create powerful items — at the highest levels, even custom-designed artifacts.]] },
  { text = [[Some special items can be inscribed with a spell and used like a spellbook.]] },
  { text = [[Carrying too much weight can slow you down.  How much you can carry depends on how strong you are.]] },
  { text = [[Spectres can pass through walls, but not easily.]] },
  { text = [[Some artifacts become even more powerful if worn together.]] },
  { text = [[Male and female DeathMolds are rumored to exist, but all observed instances have been neither.]] },
  { text = [[You can configure most items to ask you before dropping, wearing or using them.]] },
  { text = [[Some special levels can only be visited once; once you leave, you can never return.]] },
  { text = [[The more adventurous breeds of DeathMolds have mysterious powers of telekinesis and teleportation, but they can be fatiguing to use.]] },
  { text = [[Some fountains are magical, and drinking from them can have interesting effects, if you're brave (or foolish) enough.]] },
}

-- Define a profile, which is where persistent profile information lives.
profile_defs = {
  achievements = {
    -- We can't sync these online, obviously.
    nosync = true,
    no_sync = true,
    {id="index:string:40"},
    {gained_on="timestamp"},
    {who="string:50"},
    {turn="number"},
    receive=function(data, save)
      save[data.id] = {who=data.who, when=data.gained_on, turn=data.turn}
    end,
  },
}
